# Tài liệu tham khảo
[Angular.io](https://angular.io/)\
[Github](https://github.com/angular-vietnam/100-days-of-angular)\
[Youtube](https://www.youtube.com/playlist?list=PLMTyi4Bfd5pW73uXw-6jgRxDwdPYqwk0r)
# 1. Mục lục
<!-- Start Document Outline -->

* [1. Mục lục](#1-mục-lục)
* [2. Angular là gì?](#2-angular-là-gì)
	* [2.1 Giới thiệu về Angular](#21-giới-thiệu-về-angular)
* [3. Routing trong Angular](#3-routing-trong-angular)
	* [3.1 Định nghĩa và cấu hình route trong Angular](#31-định-nghĩa-và-cấu-hình-route-trong-angular)
	* [3.2 Lazy loading routes](#32-lazy-loading-routes)
	* [3.3 Route Guards và sử dụng Guard để bảo vệ route](#33-route-guards-và-sử-dụng-guard-để-bảo-vệ-route)
* [4. Lifecycle Hook](#4-lifecycle-hook)
	* [4.1 Đặc điểm của Lifecycle Hook](#41-đặc-điểm-của-lifecycle-hook)
	* [4.2 Các loại Lifecycle Hook](#42-các-loại-lifecycle-hook)
* [5. Service](#5-service)
	* [5.1 Service trong Angular](#51-service-trong-angular)
	* [5.2 Dependency Injection và sử dụng service](#52-dependency-injection-và-sử-dụng-service)
* [6. Route guards](#6-route-guards)
* [7. Style và CSS](#7-style-và-css)
	* [7.1 Component styling: inline styles, styleUrls](#71-component-styling-inline-styles-styleurls)
	* [7.2 Global styles và thay đổi trên toàn dự án](#72-global-styles-và-thay-đổi-trên-toàn-dự-án)
* [8. RxJS](#8-rxjs)
	* [8.1 Observables, Operators, Subjects](#81-observables-operators-subjects)
	* [8.2 Tác dụng RxJS trong Angular](#82-tác-dụng-rxjs-trong-angular)
* [9. Directive](#9-directive)
* [10. Form](#10-form)
	* [10.1 Reactive Forms](#101-reactive-forms)
	* [10.2 Validation và Form Submission](#102-validation-và-form-submission)

<!-- End Document Outline -->
# 2. Angular là gì?
## 2.1 Giới thiệu về Angular
**Angular là một framework phát triển ứng dụng web do Google phát triển. Nó cho phép bạn xây dựng các ứng dụng web động và đa nền tảng bằng việc sử dụng HTML, CSS và JavaScript/TypeScript. Angular sử dụng kiến trúc MVVM (Model-View-ViewModel) và cung cấp nhiều tính năng mạnh mẽ như data binding, dependency injection, routing và quản lý trạng thái ứng dụng.**
# 3. Routing trong Angular
## 3.1 Định nghĩa và cấu hình route trong Angular 
**_ Route giúp tạo ra các trang và điều hướng đến chúng trong trang web**\
**_ Route cho phép điều hướng qua lại giữa các trang mà không cần tải lại toàn bộ ứng dụng**\
![styleUrl](./image/image1.png){width=100%}\
![styleUrl](./image/iamge2.img.png){width=100%}\
## 3.2 Lazy loading routes
**Cho phép tải các module và route khi cần thiết. thay vì tải toàn bộ ứng dụng từ đầu**
## 3.3 Route Guards và sử dụng Guard để bảo vệ route
**_ Chúng giúp kiểm tra và quyết định liệu người dùng có được phép truy cập vào một route hay không. Sử dụng Guards, có thể thiết lập các quy tắc bảo vệ, kiểm tra quyền truy cập và thực hiện các hành động trước khi điều hướng tới một trang.**\
**_ Các loại Guards chính: CanActivate, CanActivateChild**
- CanActivate: kiểm tra xem người dùng có được phép truy cập không
- CanActivateChild: kiểm tra xem người dùng có được phép truy cập vào component con không
- CanDeactivate: kiểm tra xem người dùng có được phép thoát ra không
# 4. Lifecycle Hook
## 4.1 Đặc điểm của Lifecycle Hook
**Lifecycle hooks trong Angular là các phương thức có thể cung cấp trong các Component để thực hiện các hành động tại các giai đoạn cụ thể của vòng đời Component.**
## 4.2 Các loại Lifecycle Hook
- ngOnChanges: Được gọi khi có sự thay đổi đầu vào (input properties) của component.
- ngOnInit: Được gọi khi component được khởi tạo. Thường được sử dụng để khởi tạo dữ liệu.\
![styleUrl](./image/image3.png){width=100%}\
- ngDoCheck: Được gọi trong mỗi chu kỳ kiểm tra của Angular để kiểm tra các thay đổi và xử lý thêm.
- ngAfterContentInit: Được gọi sau khi Angular đã nhúng nội dung bên trong component.
- ngAfterContentChecked: Được gọi sau khi Angular đã kiểm tra nội dung bên trong component.
- ngAfterViewInit: Được gọi sau khi component đã khởi tạo xong view (view của thành phần hiện tại).
- ngAfterViewChecked: Được gọi sau khi Angular đã kiểm tra view.
- ngOnDestroy: Được gọi trước khi component bị hủy bỏ và dọn dẹp tài nguyên.
# 5. Service 
## 5.1 Service trong Angular
**_ Service trong Angular là một thành phần được sử dụng để chia sẻ logic, dữ liệu và chức năng giữa các thành phần khác nhau của ứng dụng như các components, directives và other services.**\
![styleUrl](./image/image6.png){width=100%}\
## 5.2 Dependency Injection và sử dụng service
**_ Khi khai báo một service trong constructor của một component, Angular sẽ tự động inject instance của service đó vào component.**
# 6. Route guards
**_ Route Guards là các thành phần được sử dụng để kiểm tra hoặc thay đổi việc điều hướng trong ứng dụng.**\
**_  Route Guards được sử dụng để bảo vệ các route và quyết định liệu người dùng có được phép truy cập vào một route cụ thể hay không.**\
![styleUrl](./image/image7.png){width=100%}\
# 7. Style và CSS 
## 7.1 Component styling: inline styles, styleUrls
**_ styleUrl: Tạo ra một file css riêng và liên kết chúng với Component bằng cách sử dụng thuộc tính `styleUrls` trong decorator `@Component`**\
![styleUrl](./image/iamge4.img.png){width=100%}\
**_ inline styles: trực tiếp trong decorator `@Component` bằng cách sử dụng thuộc tính `styles`**\
![styleUrl](./image/image5.png){width=100%}
## 7.2 Global styles và thay đổi trên toàn dự án
**Sử dụng global styles để áp dụng kiểu trên toàn bộ dự án**
# 8. RxJS
## 8.1 Observables, Operators, Subjects
**_ RxJS là một thư viện cung cấp các khái niệm như Observables, đại diện cho một dãy sự kiện hoặc giá trị trên thời gian.**\
**_ Operators được sử dụng để xử lý và biến đổi dữ liệu thu được từ Observables.**
## 8.2 Tác dụng RxJS trong Angular
**_ RxJS bạn xử lý các sự kiện không đồng bộ, xử lý dữ liệu từ các API hoặc sự thay đổi trong giao diện người dùng.**
# 9. Directive 
**_ Directive là một cách để mở rộng và thay đổi hành vi của các thành phần trong Angular, có thể được sử dụng để thêm các logic tùy chỉnh vào các phần tử HTML, kiểm soát hiển thị hoặc thay đổi cách tương tác với các component.**
# 10. Form
## 10.1 Reactive Forms
**_ Reactive Forms là một phương pháp để xử lý và quản lý form trong Angular bằng cách sử dụng Reactive Programming.**\
**_ Reactive Forms giúp tạo các form linh hoạt, kiểm soát trạng thái và xử lý dữ liệu có được từ form một cách dễ dàng.**
## 10.2 Validation và Form Submission
**_ Validation: kiểm tra tính hợp lệ của dữ liệu nhập vào trong form**\
**_ Các kiểu Validation:**
- Required
- MinLength
- MaxLength 
- Pattern
- Email

